<?php
/**
 * @brief		bookmark content Application Class
 * @author		<a href=''></a>
 * @copyright	(c) 2017 
 * @package		IPS Community Suite
 * @subpackage	bookmark content
 * @since		22 Apr 2017
 * @version		
 */
 
namespace IPS\bookmark;

use IPS\Member\Group;

/**
 * bookmark content Application Class
 */
class _Application extends \IPS\Application
{
	CONST EVENT_bookmark_added = 'fosters.bookmark.added';
	CONST EVENT_bookmark_removed = 'fosters.bookmark.removed';

	protected $fostersData = [
		'ips.file' => 'https://invisioncommunity.com/files/file/8582-bookmarks/',
		'ips.topic' => 'https://invisioncommunity.com/forums/topic/438150-fosters-bookmarks-supporttopic/',
		'github.repo' => 'https://github.com/Fosters-IPS/bookmark'
	];

	/**
	 * [Node] Get Node Icon
	 *
	 * @return	string
	 */
	protected function get__icon()
	{
		return 'bookmark';
	}


	public function canUseBookmarks( $checkForPrivat = FALSE )
	{
		if ( !\IPS\Member::loggedIn()->member_id )
		{
			return FALSE;
		}
		$bookmarkPerms = Group::bookmarkPerms(\IPS\Member::loggedIn()->member_group_id);
		if( $checkForPrivat)
		{
			return $bookmarkPerms['can_create_private_bookmarks'];
		}
		return $bookmarkPerms['can_create_bookmarks'];
	}

	public function isSimpleMode()
	{
		if ( \IPS\Settings::i()->bookmark_simplemode )
		{
			\IPS\Output::i()->jsVars['bookmark_simplemode'] = 1;
			return TRUE;
		}
		return FALSE;
	}

	public function installOther()
    {
        foreach( \IPS\Member\Group::groups( TRUE, FALSE ) as $group )
        {
            \IPS\Db::i()->insert('bookmark_grouppermissions',[
                'group_id' => $group->g_id,
                'can_create_bookmarks' => 1,
                'can_create_private_bookmarks' => 1
            ] );
        }
    }

}
