//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class bookmark_hook_settings extends _HOOK_CLASS_
{

	public function execute()
	{
		try
		{
			try
			{
				if ( isset( \IPS\Request::i()->tab ) AND \IPS\Request::i()->tab == 'bookmarks')
				{
					$this->tabs['bookmarks'] = 'bookmarks';
		
					/* Choose active tab */
					if ( isset( \IPS\Request::i()->tab ) and array_key_exists( \IPS\Request::i()->tab, $this->tabs ) )
					{
						$this->activeTab = \IPS\Request::i()->tab;
					}
					else
					{
						$keys = array_keys( $this->tabs );
						$this->activeTab = array_shift( $keys );
					}
		
					$this->manage();
				}
				else
				{
					parent::execute();
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	protected function manage()
	{
		try
		{
			try
			{
				$this->tabs['bookmarks'] = 'bookmarks';
				parent::manage();
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	protected function _manageBookmarks()
	{
		try
		{
			try
			{
				$form = new \IPS\Helpers\Form();
				$form->add( new \IPS\Helpers\Form\YesNo( 'bookmark_simplemode', \IPS\Settings::i()->bookmark_simplemode ) );
				$form->add( new \IPS\Helpers\Form\YesNo( 'bookmark_autosticky', \IPS\Settings::i()->bookmark_autosticky ) );
		        $form->add( new \IPS\Helpers\Form\YesNo( 'bookmark_useicon', \IPS\Settings::i()->bookmark_useicon ) );
		        $form->add( new \IPS\Helpers\Form\YesNo( 'bookmark_hide_export', \IPS\Settings::i()->bookmark_hide_export ) );
		
				if ( $values = $form->values() )
				{
					$form->saveAsSettings( $values );
		
					\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=core&module=settings&controller=posting&tab=bookmarks' ), 'saved' );
				}
		
				return $form;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}